/* eslint-disable import/no-unresolved, import/extensions */
import { Dimensions } from 'react-native';
import isPlainObject from 'isobject';
import { match } from 'css-mediaquery';
import { isMediaQuery } from 'fela-utils';
import { assignStyle } from 'css-in-js-utils';
import DimensionProvider from './components/DimensionProvider';

function getOrientation(width, height) {
  return width > height ? 'landscape' : 'portrait';
}

function nativeMediaQueryPlugin(style) {
  var _Dimensions$get = Dimensions.get('window'),
      width = _Dimensions$get.width,
      height = _Dimensions$get.height;

  for (var property in style) {
    var value = style[property];

    if (isMediaQuery(property) && isPlainObject(value)) {
      if (match(property.slice(6).trim(), {
        type: 'screen',
        orientation: getOrientation(width, height),
        width: width,
        height: height
      })) {
        assignStyle(style, value);
      }

      delete style[property];
    }
  }

  return style;
}

export default function nativeMediaQuery() {
  return nativeMediaQueryPlugin;
}
export { DimensionProvider };