"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "DimensionProvider", {
  enumerable: true,
  get: function get() {
    return _DimensionProvider["default"];
  }
});
exports["default"] = nativeMediaQuery;

var _reactNative = require("react-native");

var _isobject = _interopRequireDefault(require("isobject"));

var _cssMediaquery = require("css-mediaquery");

var _felaUtils = require("fela-utils");

var _cssInJsUtils = require("css-in-js-utils");

var _DimensionProvider = _interopRequireDefault(require("./components/DimensionProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable import/no-unresolved, import/extensions */
function getOrientation(width, height) {
  return width > height ? 'landscape' : 'portrait';
}

function nativeMediaQueryPlugin(style) {
  var _Dimensions$get = _reactNative.Dimensions.get('window'),
      width = _Dimensions$get.width,
      height = _Dimensions$get.height;

  for (var property in style) {
    var value = style[property];

    if ((0, _felaUtils.isMediaQuery)(property) && (0, _isobject["default"])(value)) {
      if ((0, _cssMediaquery.match)(property.slice(6).trim(), {
        type: 'screen',
        orientation: getOrientation(width, height),
        width: width,
        height: height
      })) {
        (0, _cssInJsUtils.assignStyle)(style, value);
      }

      delete style[property];
    }
  }

  return style;
}

function nativeMediaQuery() {
  return nativeMediaQueryPlugin;
}